



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>线程池之 newScheduledThreadPool中scheduleAtFixedRate（四个参数）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">线程池之 newScheduledThreadPool中scheduleAtFixedRate（四个参数）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 04:53:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转自：https://blog.csdn.net/weixin_35756522/article/details/81707276</p>
<p>说明：在处理消费数据的时候，统计tps，需要用一个线程监控来获得tps值，则使用了定时任务的线程池中的方法</p>
<pre class="prettyprint linenums">scheduleAtFixedRate（），此方法有四个参数</pre>
<p>一：简单说明</p>
<p>ScheduleExecutorService接口中有四个重要的方法，其中scheduleAtFixedRate和scheduleWithFixedDelay在实现定时程序时比较方便。</p>
<p>下面是该接口的原型定义</p>
<p>java.util.concurrent.ScheduleExecutorService extends&nbsp;ExecutorService extends&nbsp;Executor</p>
<p><img referrerpolicy="no-referrer"src="https://img-my.csdn.net/uploads/201301/08/1357634276_4741.jpg" /></p>
<p>接口scheduleAtFixedRate原型定义及参数说明</p>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>public ScheduledFuture&lt;?&gt; scheduleAtFixedRate(Runnable command,</code></p></li>
<li><p><code>long initialDelay,</code></p></li>
<li><p><code>long period,</code></p></li>
<li><p><code>TimeUnit unit);</code></p></li></ol>
<p>command：执行线程<br />initialDelay：初始化延时<br />period：两次开始执行最小间隔时间<br />unit：计时单位</p>
<p>接口scheduleWithFixedDelay原型定义及参数说明</p>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>public ScheduledFuture&lt;?&gt; scheduleWithFixedDelay(Runnable command,</code></p></li>
<li><p><code>long initialDelay,</code></p></li>
<li><p><code>long delay,</code></p></li>
<li><p><code>TimeUnit unit);</code></p></li></ol>
<p>command：执行线程<br />initialDelay：初始化延时<br />period：前一次执行结束到下一次执行开始的间隔时间（间隔执行延迟时间）<br />unit：计时单位</p>
<p>二：功能示例</p>
<p>1.按指定频率周期执行某个任务。</p>
<p>初始化延迟0ms开始执行，每隔100ms重新执行一次任务。</p>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>/**</code></p></li>
<li><p><code>* 以固定周期频率执行任务</code></p></li>
<li><p><code>*/</code></p></li>
<li><p><code>public static void executeFixedRate() {</code></p></li>
<li><p><code>ScheduledExecutorService executor = Executors.newScheduledThreadPool(1);</code></p></li>
<li><p><code>executor.scheduleAtFixedRate(</code></p></li>
<li><p><code>new EchoServer(),</code></p></li>
<li><p><code>0,</code></p></li>
<li><p><code>100,</code></p></li>
<li><p><code>TimeUnit.MILLISECONDS);</code></p></li>
<li><p><code>}</code></p></li></ol>
<p>间隔指的是连续两次任务开始执行的间隔。</p>
<p>2.按指定频率间隔执行某个任务。</p>
<p>初始化时延时0ms开始执行，本次执行结束后延迟100ms开始下次执行。</p>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>/**</code></p></li>
<li><p><code>* 以固定延迟时间进行执行</code></p></li>
<li><p><code>* 本次任务执行完成后，需要延迟设定的延迟时间，才会执行新的任务</code></p></li>
<li><p><code>*/</code></p></li>
<li><p><code>public static void executeFixedDelay() {</code></p></li>
<li><p><code>ScheduledExecutorService executor = Executors.newScheduledThreadPool(1);</code></p></li>
<li><p><code>executor.scheduleWithFixedDelay(</code></p></li>
<li><p><code>new EchoServer(),</code></p></li>
<li><p><code>0,</code></p></li>
<li><p><code>100,</code></p></li>
<li><p><code>TimeUnit.MILLISECONDS);</code></p></li>
<li><p><code>}</code></p></li></ol>
<p>3.周期定时执行某个任务。</p>
<p>有时候我们希望一个任务被安排在凌晨3点（访问较少时）周期性的执行一个比较耗费资源的任务，可以使用下面方法设定每天在固定时间执行一次任务。</p>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>/**</code></p></li>
<li><p><code>* 每天晚上8点执行一次</code></p></li>
<li><p><code>* 每天定时安排任务进行执行</code></p></li>
<li><p><code>*/</code></p></li>
<li><p><code>public static void executeEightAtNightPerDay() {</code></p></li>
<li><p><code>ScheduledExecutorService executor = Executors.newScheduledThreadPool(1);</code></p></li>
<li><p><code>long oneDay = 24 * 60 * 60 * 1000;</code></p></li>
<li><p><code>long initDelay = getTimeMillis("20:00:00") - System.currentTimeMillis();</code></p></li>
<li><p><code>initDelay = initDelay &gt; 0 ? initDelay : oneDay + initDelay;</code></p></li>
<li><p><code>executor.scheduleAtFixedRate(</code></p></li>
<li><p><code>new EchoServer(),</code></p></li>
<li><p><code>initDelay,</code></p></li>
<li><p><code>oneDay,</code></p></li>
<li><p><code>TimeUnit.MILLISECONDS);</code></p></li>
<li><p><code>}</code></p></li></ol>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>/**</code></p></li>
<li><p><code>* 获取指定时间对应的毫秒数</code></p></li>
<li><p><code>* @param time "HH:mm:ss"</code></p></li>
<li><p><code>* @return</code></p></li>
<li><p><code>*/</code></p></li>
<li><p><code>private static long getTimeMillis(String time) {</code></p></li>
<li><p><code>try {</code></p></li>
<li><p><code>DateFormat dateFormat = new SimpleDateFormat("yy-MM-dd HH:mm:ss");</code></p></li>
<li><p><code>DateFormat dayFormat = new SimpleDateFormat("yy-MM-dd");</code></p></li>
<li><p><code>Date curDate = dateFormat.parse(dayFormat.format(new Date()) + " " + time);</code></p></li>
<li><p><code>return curDate.getTime();</code></p></li>
<li><p><code>} catch (ParseException e) {</code></p></li>
<li><p><code>e.printStackTrace();</code></p></li>
<li><p><code>}</code></p></li>
<li><p><code>return 0;</code></p></li>
<li><p><code>}</code></p></li></ol>
<p>4.辅助代码</p>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>class EchoServer implements Runnable {</code></p></li>
<li><p><code>@Override</code></p></li>
<li><p><code>public void run() {</code></p></li>
<li><p><code>try {</code></p></li>
<li><p><code>Thread.sleep(50);</code></p></li>
<li><p><code>} catch (InterruptedException e) {</code></p></li>
<li><p><code>e.printStackTrace();</code></p></li>
<li><p><code>}</code></p></li>
<li><p><code>System.out.println("This is a echo server. The current time is " +</code></p></li>
<li><p><code>System.currentTimeMillis() + ".");</code></p></li>
<li><p><code>}</code></p></li>
<li><p><code>}</code></p></li></ol>
<p>三：一些问题</p>
<p>上面写的内容有不严谨的地方，比如对于scheduleAtFixedRate方法，当我们要执行的任务大于我们指定的执行间隔时会怎么样呢？</p>
<p>对于中文API中的注释，我们可能会被忽悠，认为无论怎么样，它都会按照我们指定的间隔进行执行，其实当执行任务的时间大于我们指定的间隔时间时，它并不会在指定间隔时开辟一个新的线程并发执行这个任务。而是等待该线程执行完毕。</p>
<p>源码注释如下：</p>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>* Creates and executes a periodic action that becomes enabled first</code></p></li>
<li><p><code>* after the given initial delay, and subsequently with the given</code></p></li>
<li><p><code>* period; that is executions will commence after</code></p></li>
<li><p><code>* &lt;tt&gt;initialDelay&lt;/tt&gt; then &lt;tt&gt;initialDelay+period&lt;/tt&gt;, then</code></p></li>
<li><p><code>* &lt;tt&gt;initialDelay + 2 * period&lt;/tt&gt;, and so on.</code></p></li>
<li><p><code>* If any execution of the task</code></p></li>
<li><p><code>* encounters an exception, subsequent executions are suppressed.</code></p></li>
<li><p><code>* Otherwise, the task will only terminate via cancellation or</code></p></li>
<li><p><code>* termination of the executor. If any execution of this task</code></p></li>
<li><p><code>* takes longer than its period, then subsequent executions</code></p></li>
<li><p><code>* may start late, but will not concurrently execute.</code></p></li></ol>
<p>根据注释中的内容，我们需要注意的时，我们需要捕获最上层的异常，防止出现异常中止执行，导致周期性的任务不再执行。</p>
<p>四：除了我们自己实现定时任务之外，我们可以使用Spring帮我们完成这样的事情。</p>
<p>Spring自动定时任务配置方法（我们要执行任务的类名为com.study.MyTimedTask）</p>
<pre class="prettyprint linenums"><code>&lt;bean id="myTimedTask" class="com.study.MyTimedTask"/&gt;</code></pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>&lt;bean id="doMyTimedTask" class="org.springframework.scheduling.quartz.MethodInvokingJobDetailFactoryBean"&gt;</code></p></li>
<li><p><code>&lt;property name="targetObject" ref="myTimedTask"/&gt;</code></p></li>
<li><p><code>&lt;property name="targetMethod" value="execute"/&gt;</code></p></li>
<li><p><code>&lt;property name="concurrent" value="false"/&gt;</code></p></li>
<li><p><code>&lt;/bean&gt;</code></p></li></ol>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>&lt;bean id="myTimedTaskTrigger" class="org.springframework.scheduling.quartz.CronTriggerBean"&gt;</code></p></li>
<li><p><code>&lt;property name="jobDetail" ref="doMyTimedTask"/&gt;</code></p></li>
<li><p><code>&lt;property name="cronExpression" value="0 0 2 * ?"/&gt;</code></p></li>
<li><p><code>&lt;/bean&gt;</code></p></li></ol>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>&lt;bean id="doScheduler" class="org.springframework.scheduling.quartz.SchedulerFactoryBean"&gt;</code></p></li>
<li><p><code>&lt;property name="triggers"&gt;</code></p></li>
<li><p><code>&lt;list&gt;</code></p></li>
<li><p><code>&lt;ref local="myTimedTaskTrigger"/&gt;</code></p></li>
<li><p><code>&lt;/list&gt;</code></p></li>
<li><p><code>&lt;/property&gt;</code></p></li>
<li><p><code>&lt;/bean&gt;</code></p></li></ol>
<pre class="prettyprint linenums">&nbsp;</pre>
<ol><li><p><code>&lt;bean id="doScheduler" class="org.springframework.scheduling.quartz.SchedulerFactoryBean"&gt;</code></p></li>
<li><p><code>&lt;property name="triggers"&gt;</code></p></li>
<li><p><code>&lt;list&gt;</code></p></li>
<li><p><code>&lt;bean class="org.springframework.scheduling.quartz.CronTriggerBean"&gt;</code></p></li>
<li><p><code>&lt;property name="jobDetail"/&gt;</code></p></li>
<li><p><code>&lt;bean id="doMyTimedTask" class="org.springframework.scheduling.quartz.MethodInvokingJobDetailFactoryBean"&gt;</code></p></li>
<li><p><code>&lt;property name="targetObject"&gt;</code></p></li>
<li><p><code>&lt;bean class="com.study.MyTimedTask"/&gt;</code></p></li>
<li><p><code>&lt;/property&gt;</code></p></li>
<li><p><code>&lt;property name="targetMethod" value="execute"/&gt;</code></p></li>
<li><p><code>&lt;property name="concurrent" value="false"/&gt;</code></p></li>
<li><p><code>&lt;/bean&gt;</code></p></li>
<li><p><code>&lt;/property&gt;</code></p></li>
<li><p><code>&lt;property name="cronExpression" value="0 0 2 * ?"/&gt;</code></p></li>
<li><p><code>&lt;/bean&gt;</code></p></li>
<li><p><code>&lt;/list&gt;</code></p></li>
<li><p><code>&lt;/property&gt;</code></p></li>
<li><p><code>&lt;/bean&gt;</code></p></li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/65qxdj9y.html">【&period;net 深呼吸】细说CodeDom（5）：类型成员</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw52yq7.html">iOS - 模态Model视图跳转和Push视图跳转的混合需求实现原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kpg6j9.html">第二天ci项目规划 前后台分离</a>
		</li>
						<li><a href="https://www.batexi.com/a/4953kpm8.html">Linux Linux程序练习十九</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1pv32q.html">WordPress基础：自定义菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j21748.html">iOS按钮设置图片在上文字在下</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mk360q.html">计算软键盘的高度然后确定自定义的View的具体位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvw20x9.html">Canvas 属性&comma;方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxg47z9.html">nsurl 测试ATS</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g72779.html">SQL中的取整函数FLOOR、ROUND、CEIL、TRUNC、SIGN</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd762zq.html">边工作边刷题：70天一遍leetcode&colon; day 77</a>
		</li>
						<li><a href="https://www.batexi.com/a/96opggn9.html">DISCOVAR de novo</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okdvk59.html">PHP 使用 Redis</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xdj6z9.html">让jquery&period;tmpl&period;js支持index序号</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okmxx19.html">react-native使用react-art制作SVG动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp54er9.html">CSS学习笔记汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy15dyxq.html">STM32定时器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyjmoz9.html">eNSP自学入门（基础）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k45yz9.html">002&period;Create a web API with ASP&period;NET Core MVC and Visual Studio for Windows -- 【在windows上用vs与asp&period;net core mvc 创建一个 web api 程序】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv13oz1q.html">初识React-Redux之粗暴理解入门</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95g2pdzq.html">C&sol;C&plus;&plus;基础---算法概览</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4zopz9.html">&lbrack;转&rsqb;&lbrack;html&rsqb;radio 获取选中状态</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5v1xmq.html">Java的大内存分页支持</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r14vz8.html">Retrofit 使用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jldd5q.html">java打印实心10&ast;10正方形， 空心10&ast;10正方形</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m21ygoq.html">安装sublime txt3 并且设置为默认的text打开方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyz0wgq.html">00009 - cat、tail、head、tee、wc、sort文件操作和过滤</a>
			</li>
						<li><a href="https://www.batexi.com/a/960vz7j9.html">MongoDB集群搭建之主从模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g27w0q.html">禅道-bug管理系统部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r61yo9.html">第5章 IP地址和子网划分（2）&lowbar;IP地址分类和NAT技术</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
